/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// OnMessageSent - Invoked when a instant message is send.    OnMessageFailed - Invoked when a instant message sending fails.    OnMessageTimeout - Invoked when a instant message sending is timing out.    OnTextMessageSent - Invoked when a sms is sent.    OnTextMessageDelivered - Invoked when a sms is successfully delivered.
    /// </summary>
    [DataContract]
        public partial class OutboundMessagesSubscriptions :  IEquatable<OutboundMessagesSubscriptions>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="OutboundMessagesSubscriptions" /> class.
        /// </summary>
        /// <param name="onMessageSent">onMessageSent.</param>
        /// <param name="onMessageFailed">onMessageFailed.</param>
        /// <param name="onMessageTimeout">onMessageTimeout.</param>
        /// <param name="onTextMessageSent">onTextMessageSent.</param>
        /// <param name="onTextMessageDelivered">onTextMessageDelivered.</param>
        public OutboundMessagesSubscriptions(string onMessageSent = default(string), string onMessageFailed = default(string), string onMessageTimeout = default(string), string onTextMessageSent = default(string), string onTextMessageDelivered = default(string))
        {
            this.OnMessageSent = onMessageSent;
            this.OnMessageFailed = onMessageFailed;
            this.OnMessageTimeout = onMessageTimeout;
            this.OnTextMessageSent = onTextMessageSent;
            this.OnTextMessageDelivered = onTextMessageDelivered;
        }
        
        /// <summary>
        /// Gets or Sets OnMessageSent
        /// </summary>
        [DataMember(Name="onMessageSent", EmitDefaultValue=false)]
        public string OnMessageSent { get; set; }

        /// <summary>
        /// Gets or Sets OnMessageFailed
        /// </summary>
        [DataMember(Name="onMessageFailed", EmitDefaultValue=false)]
        public string OnMessageFailed { get; set; }

        /// <summary>
        /// Gets or Sets OnMessageTimeout
        /// </summary>
        [DataMember(Name="onMessageTimeout", EmitDefaultValue=false)]
        public string OnMessageTimeout { get; set; }

        /// <summary>
        /// Gets or Sets OnTextMessageSent
        /// </summary>
        [DataMember(Name="onTextMessageSent", EmitDefaultValue=false)]
        public string OnTextMessageSent { get; set; }

        /// <summary>
        /// Gets or Sets OnTextMessageDelivered
        /// </summary>
        [DataMember(Name="onTextMessageDelivered", EmitDefaultValue=false)]
        public string OnTextMessageDelivered { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class OutboundMessagesSubscriptions {\n");
            sb.Append("  OnMessageSent: ").Append(OnMessageSent).Append("\n");
            sb.Append("  OnMessageFailed: ").Append(OnMessageFailed).Append("\n");
            sb.Append("  OnMessageTimeout: ").Append(OnMessageTimeout).Append("\n");
            sb.Append("  OnTextMessageSent: ").Append(OnTextMessageSent).Append("\n");
            sb.Append("  OnTextMessageDelivered: ").Append(OnTextMessageDelivered).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as OutboundMessagesSubscriptions);
        }

        /// <summary>
        /// Returns true if OutboundMessagesSubscriptions instances are equal
        /// </summary>
        /// <param name="input">Instance of OutboundMessagesSubscriptions to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(OutboundMessagesSubscriptions input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.OnMessageSent == input.OnMessageSent ||
                    (this.OnMessageSent != null &&
                    this.OnMessageSent.Equals(input.OnMessageSent))
                ) && 
                (
                    this.OnMessageFailed == input.OnMessageFailed ||
                    (this.OnMessageFailed != null &&
                    this.OnMessageFailed.Equals(input.OnMessageFailed))
                ) && 
                (
                    this.OnMessageTimeout == input.OnMessageTimeout ||
                    (this.OnMessageTimeout != null &&
                    this.OnMessageTimeout.Equals(input.OnMessageTimeout))
                ) && 
                (
                    this.OnTextMessageSent == input.OnTextMessageSent ||
                    (this.OnTextMessageSent != null &&
                    this.OnTextMessageSent.Equals(input.OnTextMessageSent))
                ) && 
                (
                    this.OnTextMessageDelivered == input.OnTextMessageDelivered ||
                    (this.OnTextMessageDelivered != null &&
                    this.OnTextMessageDelivered.Equals(input.OnTextMessageDelivered))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.OnMessageSent != null)
                    hashCode = hashCode * 59 + this.OnMessageSent.GetHashCode();
                if (this.OnMessageFailed != null)
                    hashCode = hashCode * 59 + this.OnMessageFailed.GetHashCode();
                if (this.OnMessageTimeout != null)
                    hashCode = hashCode * 59 + this.OnMessageTimeout.GetHashCode();
                if (this.OnTextMessageSent != null)
                    hashCode = hashCode * 59 + this.OnTextMessageSent.GetHashCode();
                if (this.OnTextMessageDelivered != null)
                    hashCode = hashCode * 59 + this.OnTextMessageDelivered.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
